"use strict";

/**
 * @param {string} baseUrl
 * @param  {...string} parts
 * @returns string
 */
function joinUrl(baseUrl) {
  for (var _len = arguments.length, parts = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    parts[_key - 1] = arguments[_key];
  }
  return [baseUrl].concat(parts).filter(Boolean).map(function (part) {
    return part.replace(/^\//, '').replace(/\/$/, '');
  }).join('/');
}
module.exports = joinUrl;